	include		"calc.h"

	include		"doorsos.h"
	include		"hexlib.h"
	include		"macros.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef    	_main
	xdef		_exit
	xdef		_comment

	xdef		prositdata@0000

WIN_X			EQU	5
WIN_W			EQU	95
WIN_H			EQU	15
WIN_Y			EQU	SCREEN_HEIGHT-15-WIN_H
GRAB			EQU	8
EXIT_W			EQU	18
EXIT_H			EQU	9
EXIT_X			EQU	WIN_W-EXIT_W-2-1
EXIT_Y			EQU	3

_main:
	PROSIT_HEADER		;"Normal" DoorsOS shouldn't run this program.

	pea		w1gui(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	move.w		#WIN_H,-(sp)			;Height
	move.w		#WIN_W,-(sp)			;Width
	move.w		#WIN_Y,-(sp)			;Y Position
	move.w		#WIN_X,-(sp)			;X Position
	jsr		winlib::Create_Window		;d0.w = Window handle
	move.w		d0,WindowHandle
	move.b		#0,2(sp)
	move.w		d0,(sp)
	jsr		winlib::Open_Window
	add.w		#16,sp

\sleep	jsr		Prosit::Sleep
	bra.s		\sleep



Event_Mousebutton:
	movem.l		a0/d1,-(sp)

	move.w		MouseButton,d1
	cmp.w		#1,d1
	beq.s		\minus
	cmp.w		#2,d1
	beq.s		\plus
	bra		\done
\minus	jsr		_ROM_CALL_297
	bra		\done
\plus	jsr		_ROM_CALL_296

\done	movem.l		(sp)+,a0/d1
	rts


_exit:
Event_Quit:
	move.w		WindowHandle,-(sp)
	jsr		winlib::Close_Window
	jsr		winlib::Destroy_Window
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate
	rts

;***********************************************************************

	EVEN
w1gui	dc.w	w1gfx-w1gui
	dc.w	0,0,6,WIN_H-1,0,-1
	dc.w	GRAB+2,2,GRAB+2+10,2+10,w1b1m-w1gui,1
	dc.w	GRAB+2+12+31,2,GRAB+2+12+31+10,2+10,w1b1p-w1gui,2
	dc.w	EXIT_X,EXIT_Y,EXIT_X+EXIT_W-1,EXIT_Y+EXIT_H-1,w1b2-w1gui,-2
	dc.w	-1
;Window GUI structure, graphical part
w1gfx	dc.w	R_BOX,0,0,GRAB,WIN_H,B_FILLED_BLACK
	dc.w	R_BOX,0,0,WIN_W,WIN_H,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
w1b1m	dc.w	R_TEXT_BUTTON,GRAB+2,2,11,11,2,2,F_NORMAL,1,w1but1m-w1gfx
	dc.w	R_TEXT,GRAB+2+12,2+3,F_NORMAL,0,w1but1t-w1gfx
w1b1p	dc.w	R_TEXT_BUTTON,GRAB+2+12+31,2,11,11,2,2,F_NORMAL,1,w1but1p-w1gfx
w1b2	dc.w	R_TEXT_BUTTON,EXIT_X,EXIT_Y,EXIT_W,EXIT_H,2,2,F_NORMAL,0,wbut2t-w1gfx
	dc.w	-1
w1but1t	dc.b	"Contrast",0
w1but1m	dc.b	"-",0
w1but1p	dc.b	"+",0
wbut2t	dc.b	"Exit",0



	EVEN
prositdata@0000:
		dc.b	"cont"		;ID
		dc.w	400		;Stack size
		dc.w	0		;Message buffer size
P_Messages	dc.w	0		;No. of messages in message buffer
		dc.w	2		;No. of events
		dc.b	"moub"
		dc.l	Event_Mousebutton
		dc.b	"quit"
		dc.l	Event_Quit

_comment
	dc.b	"Prosit: Contrast",0

	BSS
WindowHandle	dc.w	0

Window_Datareturn:
WKey		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
