	include		"calc.h"

	xdef    	_main
	xdef		_exit
	xdef		_comment

	include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"userlib.h"
	include		"graphlib.h"

LIST_NEXT		EQU	0
LIST_ID			EQU	LIST_NEXT+4
LIST_HEADER_SIZE	EQU	LIST_ID+2

_main:
	clr.l		list
	clr.l		item1
	clr.l		item2
	clr.l		item3
	clr.l		item4
	clr.l		counter

	bsr		Plot

	pea		item1(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	pea		item2(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	pea		item3(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	pea		item4(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	pea		item3(pc)
	pea		list(pc)
	bsr		List_Remove
	addq.l		#8,sp
	bsr		Plot

	pea		item1(pc)
	pea		list(pc)
	bsr		List_Remove
	addq.l		#8,sp
	bsr		Plot

	pea		item2(pc)
	pea		list(pc)
	bsr		List_Remove
	addq.l		#8,sp
	bsr		Plot

	pea		item4(pc)
	pea		list(pc)
	bsr		List_Remove
	addq.l		#8,sp
	bsr		Plot

	pea		item4(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	pea		item3(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	move.w		#2,-(sp)
	pea		list(pc)
	bsr		List_Find
	addq.l		#6,sp
	HexShow		a0,#15,#20,#7
	jsr		userlib::idle_loop

	pea		item2(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	pea		item1(pc)
	pea		list(pc)
	bsr		List_Insert
	addq.l		#8,sp
	bsr		Plot

	move.w		#2,-(sp)
	pea		list(pc)
	bsr		List_Find
	addq.l		#6,sp
	HexShow		a0,#15,#20,#7
	jsr		userlib::idle_loop

_exit:
	rts

;***********************************************************************

Plot:
	jsr		graphlib::clr_scr
	move.l		list,a0
	HexShow		a0,#1,#1,#7
	cmp.l		#0,a0
	beq.s		\done

	moveq		#3,d7

\loop	HexShow		a0,d7,#1,#7		;*structure
	HexShow		(a0),d7,#10,#7		;*structure.*next
	HexShow		2(a0),d7,#19,#3		;*structure.data
	move.l		(a0),a0			;*next
	addq.w		#1,d7
	cmp.w		#12,d7
	ble.s		\loop

\done	jsr		userlib::idle_loop
	rts

;*****************
;*               *
;* LIST ROUTINES *
;*               *
;*****************

;List_Find(BYTE *list, WORD ID)
;Get a pointer to the structure in <list> with <ID>.
;Output: a0.l = *structure, 0 if not found
List_Find:
	movem.l		a1/d0,-(sp)
	move.l		4+2*4(sp),a0
	move.w		4+2*4+4(sp),d0
	move.l		(a0),a0
	move.l		a0,a1
\loop	cmp.w		LIST_ID(a0),d0
	beq.s		\done
	move.l		LIST_NEXT(a0),a0
	cmp.l		a0,a1
	bne.s		\loop
	move.l		#0,a0
\done	movem.l		(sp)+,a1/d0
	rts

;List_Previous(BYTE *structure)
;Get a pointer to the structure in <list> that points to <structure>
;Output: a0.l = *previous structure
List_Previous:
	movem.l		a1,-(sp)
	move.l		4+1*4(sp),a0	;*structure
	move.l		a0,a1		;Store *structure
\loop	cmp.l		LIST_NEXT(a0),a1
	beq.s		\done
	move.l		LIST_NEXT(a0),a0
	bra.s		\loop

\done	movem.l		(sp)+,a1
	rts

;List_Insert(BYTE *list, BYTE *structure)
;Insert <structure> first in <list>.
;Output: a0.l = *list
List_Insert:
	movem.l		a0-a2,-(sp)
	move.l		4+3*4+4(sp),a2		;*structure
	move.l		4+3*4(sp),a1		;*list
	tst.l		(a1)
	beq.s		\empty
	move.l		(a1),-(sp)
	bsr		List_Previous		;a0 = *Previous
	addq.l		#4,sp
	move.l		a2,LIST_NEXT(a0)	;Set *previous.*next = *structure
	move.l		(a1),LIST_NEXT(a2)	;Set *structure.*next = **list
	move.l		a2,(a1)			;**list = *structure
	bra.s		\done
\empty	move.l		a2,(a1)			;First item, set **list = *structure
	move.l		a2,LIST_NEXT(a2)	;...and *structure.*next = *structure
\done	movem.l		(sp)+,a0-a2
	rts

;List_Remove(BYTE *list, BYTE *structure)
;Remove <structurefrom <list>.
List_Remove:
	movem.l		a0-a2,-(sp)
	move.l		4+3*4+4(sp),a2			;*structure
	move.l		4+3*4(sp),a1			;*list
	cmp.l		LIST_NEXT(a2),a2
	beq.s		\empty

	move.l		a2,-(sp)
	bsr		List_Previous			;a0 = *Previous
	addq.l		#4,sp
	move.l		LIST_NEXT(a2),LIST_NEXT(a0)	;Set *previous.*next = *structure.*next
	cmp.l		(a1),a2	
	bne.s		\done				;Removed item wasn't first
	move.l		LIST_NEXT(a2),(a1)		;Removed item was first, update list header
	bra.s		\done
\empty	move.l		#0,(a1)
\done	movem.l		(sp)+,a0-a2
	rts

;***********************************************************************

	EVEN

;***********************************************************************

_comment
	dc.b	"Single-linked list",0

	EVEN
counter	dc.l	0

list	dc.l	0

item1	dc.l	0
	dc.w	1
item2	dc.l	0
	dc.w	2
item3	dc.l	0
	dc.w	3
item4	dc.l	0
	dc.w	4
	BSS

	END
