;*****************
;*               *
;* FILE ROUTINES *
;*               *
;*****************

;*********************************************
;* Relocate ASM file                         *
;* Input: d5.w = Handle of file              *
;* Output: a6.l = *File                      *
;*         a5.l = *_main                     *
;*         d0.w = 0 if success, -1 if failed *
;*********************************************
RelocateFile:
	movem.l		a0-a2/d1-d2/d4-d5,-(sp)

	move.w		d5,d0
	doorsos::DEREF	d0,a5		;Get adress of program variable

	moveq		#-1,d0		;Assume failure

	move.w		(a5),d1
	lea		1(a5,d1.w),a2
	cmp.b		#$F3,(a2)	;is ASM ?
	bne		\Fail		;no -> bye !
	cmp.l		#"68kP",6(a5)	;is a DoorsOS/Plusshell program ?
	bne		\Fail		; no -> bye !

	tst.w		8+2(a5)
	bgt		\Fail		;Program already relocated.

;Relocation, phase 1 (jumps, variables - PC-relative stuff)
	move.l		a5,a6		;Store program adress
	addq.l		#2,a5		;Program entry point

	clr.l		d1
	move.w		(a6)+,d1
	lea		-1(a6,d1.l),a0	;Get adress of last word in program

\rloop	clr.l		d0
	move.w		-(a0),d0
	tst.w		d0
	beq		\endr		;No more relocation points
	clr.l		d1		;Found one more relocation point at a0+d0
	move.w		-(a0),d1		;Get its offset within the program
	add.l		a5,d1		;Add program entry point to it
	move.l		d1,0(a5,d0.l)	;And store it within the program
	bra 		\rloop		;Repeat
\endr

;Relocation, second phase (libraries and stuff)
	move.w		$C(a5),d1	;Offset to _main
	lea		0(a5,d1.w),a5	;Program entry point (_main)
	move.w		d5,d0
	move.l		($38),a0

;	TOGGLE_PROSIT
	jsr		(a0)			;Relocate program, step 2
;	TOGGLE_PROSIT

	moveq		#0,d0		;Success

\Fail	movem.l		(sp)+,a0-a2/d1-d2/d4-d5
	rts
