	include		"calc.h"

	include		"doorsos.h"
	include		"hexlib.h"
	include		"macros.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef    	_main
	xdef		_exit
	xdef		_comment

	xdef		prositdata@0000

WIN1_W			EQU	SCREEN_WIDTH
WIN1_H			EQU	13
WIN1_X			EQU	0
WIN1_Y			EQU	SCREEN_HEIGHT-WIN1_H

QBUT_W			EQU	20
BUTTONS			EQU	4
BUT_X			EQU	2
BUT_Y			EQU	2
BUT_W			EQU	((WIN1_W-2*BUT_X-QBUT_W-5)/BUTTONS)-1
BUT_H			EQU	WIN1_H-4
BUT_S			EQU	BUT_W+1

_main:
	PROSIT_HEADER		;"Normal" DoorsOS shouldn't run this program.

	jsr		winlib::Init_Window_System

	pea		w1gui(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	move.w		#WIN1_H,-(sp)			;Height
	move.w		#WIN1_W,-(sp)			;Width
	move.w		#WIN1_Y,-(sp)			;Y Position
	move.w		#WIN1_X,-(sp)			;X Position
	jsr		winlib::Create_Window		;d0.w = Window handle
	move.w		d0,WindowHandle1
	move.b		#127,2(sp)
	move.w		d0,(sp)
	jsr		winlib::Open_Window
	add.w		#16,sp

	clr.w		quitvar
\sleep	jsr		Prosit::Sleep
	tst.w		quitvar
	beq.s		\sleep

	BROADCAST_EVENT	#"quit"

	move.w		WindowHandle1,d0
	doorsos::DEREF	d0,a0
\loop1	cmp.l		(a0),a0
	bne.s		\loop1

	move.w		WindowHandle1,-(sp)
	jsr		winlib::Close_Window
	jsr		winlib::Destroy_Window
	addq.l		#2,sp

	jsr		winlib::Close_Window_System

	move.w		Prosit::CurrentProcessID,d0
	doorsos::DEREF	d0,a0
\loop	cmp.l		(a0),a0
	bne.s		\loop
	rts




Event_Mousebutton:
	move.w		MouseButton,d0

	cmp.w		#1024,d0
	beq		Quit

	lsl.w		#1,d0
	lea		Programs(pc),a0
	move.w		0(a0,d0.w),d0

	pea		folder(pc)		;*Folder name
	pea		0(a0,d0.w)		;*File name
	jsr		Prosit::Get_File_Handle	;d5.w = File handle
	addq.l		#8,sp

	tst.w		d5
	beq.s		\done

	move.w		d5,-(sp)
	jsr		Prosit::Process_New
	addq.l		#2,sp

\done	rts

_exit:
Quit:
	move.w		#1,quitvar
	rts

;***********************************************************************

	EVEN

;Window #1 GUI structure, management part:
w1gui	dc.w	w1gfx-w1gui
	dc.w	BUT_X,2,BUT_X+BUT_W-1,2+BUT_H-1,w1b1-w1gui,0
	dc.w	BUT_X+BUT_S,2,BUT_X+BUT_S+BUT_W-1,2+BUT_H-1,w1b2-w1gui,1
	dc.w	BUT_X+2*BUT_S,2,BUT_X+2*BUT_S+BUT_W-1,2+BUT_H-1,w1b3-w1gui,2
	dc.w	BUT_X+3*BUT_S,2,BUT_X+3*BUT_S+BUT_W-1,2+BUT_H-1,w1b4-w1gui,3
	dc.w	WIN1_W-BUT_X-QBUT_W,2,WIN1_W-BUT_X-1,2+BUT_H-1,w1bq-w1gui,1024
	dc.w	-1
;Window #1 GUI structure, graphical part
w1gfx	dc.w	R_BOX,0,0,WIN1_W,WIN1_H,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
w1b1	dc.w	R_TEXT_BUTTON,BUT_X,2,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut1-w1gfx
w1b2	dc.w	R_TEXT_BUTTON,BUT_X+BUT_S,2,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut2-w1gfx
w1b3	dc.w	R_TEXT_BUTTON,BUT_X+2*BUT_S,2,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut3-w1gfx
w1b4	dc.w	R_TEXT_BUTTON,BUT_X+3*BUT_S,2,BUT_W,BUT_H,2,2,F_NORMAL,0,wbut4-w1gfx
w1bq	dc.w	R_TEXT_BUTTON,WIN1_W-BUT_X-QBUT_W,2,QBUT_W,BUT_H,2,2,F_NORMAL,0,wbutq-w1gfx
	dc.w	-1
wbut1	dc.b	"Contrast",0
wbut2	dc.b	"Background",0
wbut3	dc.b	"Ticks",0
wbut4	dc.b	"Tic-tac-toe",0
wbutq	dc.b	"QUIT",0

;Window #2 GUI structure, management part:
w2gui	dc.w	w2gfx-w2gui
	dc.w	-1
;Window #2 GUI structure, graphical part
w2gfx	dc.w	R_BOX,0,0,WIN1_W,WIN1_H,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
	dc.w	-1


folder		dc.b	"main",0
	EVEN
Programs:
	dc.w	program1-Programs
	dc.w	program2-Programs
	dc.w	program3-Programs
	dc.w	program4-Programs

program1	dc.b	"contrast",0
program2	dc.b	"backgrnd",0
program3	dc.b	"statline",0
program4	dc.b	"ttt",0

	EVEN

prositdata@0000:
		dc.b	"pros"		;ID
		dc.w	0		;Stack size
		dc.w	0		;Message buffer size
P_Messages	dc.w	0		;No. of messages in message buffer
		dc.w	1		;No. of events
		dc.b	"moub"
		dc.l	Event_Mousebutton

_comment
	dc.b	"Prosit: Boot",0

	BSS

WindowHandle1	dc.w	0
WindowHandle2	dc.w	0

Window_Datareturn:
WKey		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0

;StatLineID	dc.w	0
;TttID		dc.w	0
;TorID		dc.w	0

quitvar		dc.w	0

;RecieveBuffer	ds.b	100

	CODE

	END
