	include		"calc.h"

	include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef		prosit_data@0000

	xdef    	_main
	xdef		_exit
	xdef		_comment

S_X		EQU	5
S_Y		EQU	8+5+3
S_W		EQU	12
S_H		EQU	11
X_INDENT	EQU	2
Y_INDENT	EQU	2
WINDOW_WIDTH	EQU	3*S_W+2*5
WINDOW_HEIGHT	EQU	S_Y+3*S_H+4

WINDOW2_WIDTH	EQU	62
WINDOW2_HEIGHT	EQU	28

_main:
	PROSIT_HEADER		;"Normal" DoorsOS shouldn't run this program.

	pea		w1gui(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	move.w		#WINDOW_HEIGHT,-(sp)		;Height
	move.w		#WINDOW_WIDTH,-(sp)		;Width
	move.w		#30,-(sp)			;Y Position
	move.w		#10,-(sp)			;X Position
	jsr		winlib::Create_Window		;d0.w = Window handle
	move.w		d0,WindowHandle
	move.b		#0,2(sp)
	move.w		d0,(sp)
	jsr		winlib::Open_Window
	add.w		#16,sp

Restart:
	move.w		#B_FILLED_WHITE,-(sp)
	move.w		#S_H-2,-(sp)
	move.w		#S_W-2,-(sp)
	move.w		#S_Y+1,-(sp)
	move.w		#S_X+1,-(sp)
	move.w		WindowHandle,-(sp)
	moveq		#2,d5
\oloop	moveq		#2,d6
\iloop	jsr		winlib::Box
	add.w		#S_W,2(sp)
	dbra.s		d6,\iloop
	move.w		#S_X+1,2(sp)
	add.w		#S_H,4(sp)
	dbra.s		d5,\oloop
	add.w		#2*6,sp

	clr.w		WindowHandle2
	move.l		#field,a6
	move.l		#0,(a6)
	move.l		#0,4(a6)
	move.b		#0,8(a6)

	move.b		#2,Player
Main_Loop:
	neg.b		Player
	add.b		#3,Player

	pea		turn_x(pc)
	cmp.b		#1,Player
	beq.s		\iscr
	move.l		#turn_o,(sp)
\iscr	move.w		#0,-(sp)
	move.w		F_NORMAL,-(sp)
	move.w		#9,-(sp)
	move.w		#S_X,-(sp)
	move.w		WindowHandle,-(sp)
	jsr		winlib::PlotText
	jsr		winlib::Refresh_Window
	add.w		#14,sp

\sleep	jsr		Prosit::Sleep
	tst.w		MouseButton
	blt.s		\sleep

	lea		winners(pc),a0
	moveq		#7,d6
	moveq		#0,d5
	move.b		Player,d2
\loop	move.b		(a0)+,d5
	cmp.b		0(a6,d5.w),d2
	beq.s		\ok1
	addq.l		#2,a0
	bra.s		\next
\ok1	move.b		(a0)+,d5
	cmp.b		0(a6,d5.w),d2
	beq.s		\ok2
	addq.l		#1,a0
	bra.s		\next
\ok2	move.b		(a0)+,d5
	cmp.b		0(a6,d5.w),d2
	beq		Winner
\next	dbra.s		d6,\loop

	moveq		#9-1,d6
\check	tst.b		0(a6,d6.w)
	beq		Main_Loop
	dbra.s		d6,\check

	move.w		#wstr22-w2gfx,w2s+10
	bra		WinSc

Winner:
	move.w		#wstr2-w2gfx,w2s+10
	move.b		#"X",winstr
	cmp.b		#1,Player
	beq		WinSc
	move.b		#"O",winstr
WinSc:
	pea		w2gui(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	move.w		#WINDOW2_HEIGHT,-(sp)		;Height
	move.w		#WINDOW2_WIDTH,-(sp)		;Width
	move.w		#45,-(sp)			;Y Position
	move.w		#5,-(sp)			;X Position
	jsr		winlib::Create_Window		;d0.w = Window handle
	move.w		d0,WindowHandle2
	move.b		#0,2(sp)
	move.w		d0,(sp)
	jsr		winlib::Open_Window
	add.w		#16,sp

\slp	jsr		Prosit::Sleep
	cmp.w		#1024,MouseButton
	bne.s		\slp

	move.w		WindowHandle2,-(sp)
	jsr		winlib::Close_Window
	jsr		winlib::Destroy_Window
	addq.l		#2,sp
	bra		Restart

Event_Mousebutton:
	movem.l		a6/d0-d1/d7,-(sp)

	tst.w		WindowHandle2
	bne.s		\done
	move.w		MouseButton,d0
	blt.s		\done

	move.w		d0,d1
	and.w		#%0000000011111111,d0	;X
	lsr.w		#8,d1			;Y

	move.w		d1,d7
	mulu.w		#3,d7
	add.w		d0,d7

	move.l		#field,a6
	tst.b		0(a6,d7.w)
	beq.s		\free			;Square is free

	move.w		#-1,MouseButton		;Signal that player attempted something wrong
	bra.s		\done

\free	move.b		Player,0(a6,d7.w)

	mulu.w		#S_W,d0
	mulu.w		#S_H,d1
	add.w		#S_X+X_INDENT,d0
	add.w		#S_Y+Y_INDENT,d1

	pea		mask(pc)
	pea		cross(pc)
	cmp.b		#1,Player
	beq.s		\iscr
	move.l		#circle,(sp)
\iscr	move.w		d1,-(sp)
	move.w		d0,-(sp)
	move.w		WindowHandle,-(sp)
	jsr		winlib::PlotGFX
	jsr		winlib::Refresh_Window
	add.w		#14,sp

\done	movem.l		(sp)+,a6/d0-d1/d7
	rts


_exit:
Event_Quit:
	tst.w		WindowHandle2
	beq.s		\quit
	move.w		WindowHandle2,-(sp)
	jsr		winlib::Close_Window
	jsr		winlib::Destroy_Window
	addq.l		#2,sp
\quit	move.w		WindowHandle,-(sp)
	jsr		winlib::Close_Window
	jsr		winlib::Destroy_Window
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate

	EVEN
prosit_data@0000:
		dc.b	"ttt_"		;ID
		dc.w	400		;Stack size
		dc.w	0		;Message buffer size
P_Messages	dc.w	0		;No. of messages in message buffer
		dc.w	2		;No. of events
		dc.b	"moub"
		dc.l	Event_Mousebutton
		dc.b	"quit"
		dc.l	Event_Quit

;***********************************************************************

winners:
	dc.b	0,3,6
	dc.b	1,4,7
	dc.b	2,5,8
	dc.b	0,1,2
	dc.b	3,4,5
	dc.b	6,7,8
	dc.b	0,4,8
	dc.b	2,4,6

	EVEN
;Window GUI structure, management part:
w1gui	dc.w	w1gfx-w1gui
	dc.w	8,0,WINDOW_WIDTH,7,0,-1
	dc.w	1,1,7,6,w1b1-w1gui,-2
	dc.w	S_X,S_Y,S_X+S_W-1,S_Y+S_H-1,w1s11-w1gui,0
	dc.w	S_X+S_W,S_Y,S_X+2*S_W-1,S_Y+S_H-1,w1s12-w1gui,1
	dc.w	S_X+2*S_W,S_Y,S_X+3*S_W-1,S_Y+S_H-1,w1s13-w1gui,2
	dc.w	S_X,S_Y+S_H,S_X+S_W-1,S_Y+2*S_H-1,w1s21-w1gui,256
	dc.w	S_X+S_W,S_Y+S_H,S_X+2*S_W-1,S_Y+2*S_H-1,w1s22-w1gui,257
	dc.w	S_X+2*S_W,S_Y+S_H,S_X+3*S_W-1,S_Y+2*S_H-1,w1s23-w1gui,258
	dc.w	S_X,S_Y+2*S_H,S_X+S_W-1,S_Y+3*S_H-1,w1s31-w1gui,512
	dc.w	S_X+S_W,S_Y+2*S_H,S_X+2*S_W-1,S_Y+3*S_H-1,w1s32-w1gui,513
	dc.w	S_X+2*S_W,S_Y+2*S_H,S_X+3*S_W-1,S_Y+3*S_H-1,w1s33-w1gui,514
	dc.w	-1
;Window GUI structure, graphical part
w1gfx	dc.w	R_BOX,0,0,WINDOW_WIDTH,7,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK+B_FILLED_BLACK
	dc.w	R_TEXT,8,1,F_INVERTED,0,wtitle1-w1gfx
	dc.w	R_BOX,0,0,WINDOW_WIDTH,WINDOW_HEIGHT,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
w1b1	dc.w	R_GFX_BUTTON,1,1
			dc.l	clopen,clmask,clclose
w1s11	dc.w	R_TEXT_BUTTON,S_X,S_Y,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s12	dc.w	R_TEXT_BUTTON,S_X+S_W,S_Y,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s13	dc.w	R_TEXT_BUTTON,S_X+2*S_W,S_Y,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s21	dc.w	R_TEXT_BUTTON,S_X,S_Y+S_H,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s22	dc.w	R_TEXT_BUTTON,S_X+S_W,S_Y+S_H,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s23	dc.w	R_TEXT_BUTTON,S_X+2*S_W,S_Y+S_H,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s31	dc.w	R_TEXT_BUTTON,S_X,S_Y+2*S_H,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s32	dc.w	R_TEXT_BUTTON,S_X+S_W,S_Y+2*S_H,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
w1s33	dc.w	R_TEXT_BUTTON,S_X+2*S_W,S_Y+2*S_H,S_W,S_H,2,2,F_NORMAL,0,w1s1t-w1gfx
	dc.w	-1
wtitle1	dc.b	"Tic-tac-toe",0
w1s1t	dc.b	" ",0

;Window GUI structure, management part:
w2gui	dc.w	w2gfx-w2gui
	dc.w	0,0,WINDOW2_WIDTH-1,6,0,-1
	dc.w	5,WINDOW2_HEIGHT-14,WINDOW2_WIDTH-6,WINDOW2_HEIGHT-6,w2b1-w2gui,1024
	dc.w	-1
;Window GUI structure, graphical part
w2gfx	dc.w	R_BOX,0,0,WINDOW2_WIDTH,7,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK+B_FILLED_BLACK
	dc.w	R_TEXT,1,1,F_INVERTED,0,wtitle2-w2gfx
	dc.w	R_BOX,0,0,WINDOW2_WIDTH,WINDOW2_HEIGHT,B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
w2s	dc.w	R_TEXT,5,9,F_NORMAL,0,wstr2-w2gfx
w2b1	dc.w	R_TEXT_BUTTON,3,WINDOW2_HEIGHT-12,WINDOW2_WIDTH-6,9,23,2,F_NORMAL,0,wbut2-w2gfx
	dc.w	-1
wtitle2	dc.b	"Message",0
wstr22	dc.b	"     It's a tie!",0
wstr2	dc.b	"The winner is "
winstr	dc.b	"X",0
wbut2	dc.b	"OK",0

turn_x	dc.b	"Turn: X",0
turn_o	dc.b	"Turn: O",0

clopen	dc.w	1,5
	dc.b	%11111110
	dc.b	%11010110
	dc.b	%11101110
	dc.b	%11010110
	dc.b	%11111110
clclose	dc.w	1,5
	dc.b	%10000010
	dc.b	%10101010
	dc.b	%10010010
	dc.b	%10101010
	dc.b	%10000010
clmask	dc.b	%11111110
	dc.b	%11111110
	dc.b	%11111110
	dc.b	%11111110
	dc.b	%11111110

cross	dc.w	1,7
	dc.b	%11000011
	dc.b	%01100110
	dc.b	%00111100
	dc.b	%00011000
	dc.b	%00111100
	dc.b	%01100110
	dc.b	%11000011

circle	dc.w	1,7
	dc.b	%00011000
	dc.b	%01111110
	dc.b	%11100111
	dc.b	%11000011
	dc.b	%11100111
	dc.b	%01111110
	dc.b	%00011000

mask	dc.b	%11111111
	dc.b	%11111111
	dc.b	%11111111
	dc.b	%11111111
	dc.b	%11111111
	dc.b	%11111111
	dc.b	%11111111

_comment
	dc.b	"Prosit: Tic-tac-toe",0

	BSS
WindowHandle	dc.w	0
WindowHandle2	dc.w	0

field		ds.b	9
Player		dc.b	0

Window_Datareturn:
Key		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
