;Buttons
R_TEXT_BUTTON	EQU	1	;X, Y, Width, Height, XText, YText, Font, Flags, _Text
R_GFX_BUTTON	EQU	2	;X, Y, _gfx, _mask
;Graphics
R_TEXT		EQU	128	;X, Y, Flags, Font, _Text
R_BOX		EQU	129	;X, Y, Width, Height, Flags
;Window system specific stuff
R_SETCLIP	EQU	192	;X1, Y1, X2, Y2
winlib::DrawStructure		equ	winlib@0012

;---------------------------------------------------------------------
; DrawStructure(WORD ID, BYTE *structure)
;
; Function: Draw <structure> into window.
;---------------------------------------------------------------------
DrawStructure:
winlib@0011:
	movem.l		a0-a6/d0-d7,-(sp)

	moveq		#0,d7			;d7.uw = 0 means that no buttons are pressed
	move.w		4+15*4(sp),d7		;Window handle
	move.w		d7,d1
	doorsos::DEREF	d1,a0			;*window

	move.l		4+15*4+2(sp),a1		;*structure
	move.l		a1,a4			;We need a1 as an offset start point, use a4 instead

Next_Item:
	move.w		(a4)+,d1
	blt		DS_Done			;No more items, exit

	cmp.w		#R_TEXT_BUTTON,d1
	beq		DS_Text_Button
	cmp.w		#R_GFX_BUTTON,d1
	beq		DS_GXF_Button
	cmp.w		#R_TEXT,d1
	beq		DS_Text
	cmp.w		#R_BOX,d1
	beq		DS_Box
	cmp.w		#R_SETCLIP,d1
	beq		DS_SetClip
	bra		DS_Done			;Unrecognised item, exit

DS_Text_Button:
	movem.w		(a4)+,d1-d4	;X, Y, Width, Height

	move.w		#%0110000000000000,-(sp)	;Pattern for left line
	move.w		#%1010000000000000,-(sp)	;Pattern for top line
	move.w		#%0000101011101011,-(sp)	;Flags
	move.w		d4,-(sp)	;Height
	move.w		d3,-(sp)	;Width
	move.w		d2,-(sp)	;Y
	move.w		d1,-(sp)	;X
	move.w		d7,-(sp)	Window ID
	bsr		Box
	add.w		#8*2,sp

	add.w		d1,d3
	subq.w		#1,d3
	add.w		d2,d4
	subq.w		#1,d4

	add.w		(a4)+,d1
	add.w		(a4)+,d2
	sub.l		#14,sp
	move.w		d7,(sp)		;Window
	move.w		d1,2(sp)	;x
	move.w		d2,4(sp)	;y
	move.w		(a4)+,6(sp)	;flags
	move.w		(a4)+,8(sp)	;font
	move.w		(a4)+,d1
	lea		0(a1,d1.w),a3	;*string
	move.l		a3,10(sp)
	bsr		PlotText
	add.w		#14,sp
	bra		Next_Item

DS_GXF_Button:
	movem.l		(a4)+,d1-d3	;X/Y, *gfx, *mask
	addq.l		#4,a4		;skip *pressed
	swap		d1
	move.l		d3,-(sp)	;*mask
	move.l		d2,-(sp)	;*gfx
	move.l		d1,-(sp)	;Y/X
	move.w		d7,-(sp)	Window ID
	bsr		PlotGFX
	add.w		#2+3*4,sp
	bra		Next_Item

DS_Text:
	sub.l		#14,sp
	move.w		d7,(sp)		;Window
	move.w		(a4)+,2(sp)	;x
	move.w		(a4)+,4(sp)	;y
	move.w		(a4)+,6(sp)	;flags
	move.w		(a4)+,8(sp)	;font
	move.w		(a4)+,d1
	lea		0(a1,d1.w),a3	;*string
	move.l		a3,10(sp)
	bsr		PlotText
	add.w		#14,sp
	bra		Next_Item

DS_Box:

; Box(WORD ID, WORD x, WORD y, WORD width, WORD height, WORD flags,
;  [WORD pattern], [WORD pattern], [WORD pattern], [WORD pattern],
;  [BYTE *gfx, BYTE *mask]

;R_BOX		EQU	129	;X, Y, Width, Height, Flags, [WORD PATTERN]

	movem.w		(a4)+,d0-d4	;X, Y, Width, Height, Flags
	move.w		d4,-(sp)	;Flags
	move.w		d3,-(sp)	;Height
	move.w		d2,-(sp)	;Width
	move.w		d1,-(sp)	;Y
	move.w		d0,-(sp)	;X
	move.w		d7,-(sp)	;Window ID

	bsr		Box
	add.w		#6*2,sp
	bra		Next_Item

DS_SetClip:
	move.l		a4,-(sp)
	move.w		d7,-(sp)
	bsr		SetClip
	add.w		#6,sp
	add.w		#8,a4
	bra		Next_Item

DS_Done:
	movem.l		(sp)+,a0-a6/d0-d7
	rts
